# -sam k (commport5@lucidx.com)

use POSIX qw(strftime);
use pdump::Sniff;

sub check_icmp {
 unless ($spfp) {
 my ($icmpo, $cicmp) = ($offset_icmp, $_[2]);
 $time = timem();
 $untm = time();
 $time =~ s/^.*?\.(.*?)$/$1/;
 $packet_icmp->bset($cicmp, $icmpo);
 $proto = $packet_icmp->proto;
 my ($vers,$ihl,$tos,$tot,$iid,$frg,$ttl,$pro,$chc,$saddr,$daddr,$type,$code,$chk,$gateway,$id,$seq,$unu,$mtu,$data) =
 $packet_icmp->get({ip=>['version','ihl','tos','tot_len','id','frag_off','ttl','protocol','check','saddr','daddr'],
 icmp=>['type','code','check','gateway','id','sequence','unused','mtu','data']});
 if ($dmth) {
  $flags = unpack("B8", substr($cicmp, $icmpo+20+13, 1));
  substr($flags, 6, 1) == '1' || substr($flags, 7, 1) == '1';
  %pd = &getpckt($icmpo);
  if ($nons) {
   $sname = $pd{'saddr'};
   $dname = $pd{'daddr'};
   $stest = $sname;
   $dtest = $dname;
  }
  else {
   $sname = $pd{'shost'};
   $dname = $pd{'dhost'};
   $stest = $pd{'saddr'};
   $dtest = $pd{'daddr'};
  }
 }
 else {
  if ($nons) {
   $sname = &ip2dot($saddr);
   $dname = &ip2dot($daddr);
   $stest = $sname;
   $dtest = $dname;
  }
  else {
   $sname = &ip2name($saddr);
   $dname = &ip2name($daddr);
   $stest = &ip2dot($saddr);
   $dtest = &ip2dot($daddr);
  }
 }
 if ($ignr) {
  unless ($gnrc) {
   if ($sname =~ /$regx/ or $dname =~ /$regx/ or $stest =~ /$regx/ or $dtest =~ /$regx/) {
    $nite++;
   }
  }
  else {
   if ($sname =~ /$regx/i or $dname =~ /$regx/i or $stest =~ /$regx/i or $dtest =~ /$regx/i) {
    $nite++;
   }
  }
 }
 if ($nofl and !$fl) {
  $dname =~ s/^([^\.]+)\..*?$/$1/;
  $sname =~ s/^([^\.]+)\..*?$/$1/;
 }
 unless ($nite) {
  $top++;
  if ($ngrp) {
   if ($data) {
    unless ($ngrx) {
     if ($ngrc) {
      if ($ngra) {
       unless ($ansi) {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
       else {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
      }
      else {
       if ($data =~ /$ngrr/i) {
        unless ($ansi) {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
        else {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
       }
       else {
        print "#";
       }
      }
     }
     else {
      if ($ngra) {
       unless ($ansi) {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
       else {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
      }
      else {
       if ($data =~ /$ngrr/) {
        unless ($ansi) {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
        else {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
       }
       else {
        print "#";
       }
      }
     }
    }
    else {
     if ($ngrc) {
      if ($ngra) {
       unless ($ansi) {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
       else {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
      }
      else {
       if ($data !~ /$ngrr/i) {
        unless ($ansi) {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
        else {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
       }
       else {
        print "#";
       }
      }
     }
     else {
      if ($ngra) {
       unless ($ansi) {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
       else {
        print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
       }
      }
      else {
       if ($data !~ /$ngrr/) {
        unless ($ansi) {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
        else {
         print "\nI $stest:$sport -> $dtest:$dport\n$data..\n";
        }
       }
       else {
        print "#";
       }
      }
     }
    }
   }
  }
  elsif ($strn) {
   $tm = strftime "%H:%M:%S", localtime;
   $tm .= ".$time";
   $str = $strg;
   %string = (
        "saddr", $stest,
        "daddr", $dtest,
        "source", $sname,
        "dest", $dname,
        "shost", $sname,
        "dhost", $dname,
        "sserv", $stype,
        "dserv", $dtype,
        "version", $vers,
        "ihl", $ihl,
        "tos", $tos,
        "totlen", $tot,
        "id", $id,
        "fragoff", $frg,
        "ttl", $ttl,
        "protocol", $pro,
        "proto", $prt,
        "check1", $chc,
        "rawsaddr", $saddr,
        "rawdaddr", $daddr,
        "sport", $sport,
        "dport", $dport,
        "sequence", $seq,
        "seq", $seq,
        "ackseq", $aseq,
        "doff", $dof,
        "res1", $res1,
        "res2", $res2,
        "urg", $urg,
        "ack", $ack,
        "psh", $psh,
        "rst", $rst,
        "syn", $syn,
        "fin", $fin,
        "winsize", $win,
        "check2", $chk,
        "data", $data,
        "time", $tm,
        "headers", $headers,
   );
   $string{"seq"} =~ s/^-//;
   $string{"sequence"} =~ s/^-//;
   $string{"ackseq"} =~ s/^-//;
   $strg =~ s/\\t/\t/g;
   $strg =~ s/\\n/\n/g;
   $strg =~ s/\$([A-Za-z0-9]+)/$string{$1}/g;
   unless ($str =~ /^[\s\\]*\$data[\s\\]*$/ and $data =~ /^\s*$/) {
    print "$strg\n";
   }
  }
  else {
   unless ($ansi) {
    print "\r";
    if ($tstm == 2) {
     print "$untm.$time ";
    }
    if ($tstm != 1 and $tstm != 2) {
     print strftime "%H:%M:%S", localtime;
     print ".$time ";
    }
    print "$sname > $dname: icmp: type $type code $code check $chk gateway $gateway id $id mtu $mtu";
    if ($verb) {
     print " (ttl $ttl, id $iid)";
    }
    if ($hex and !$hexa) {
     if ($data) {
      print "\n";
      ($ndata = $data) =~ s/(.{1})/sprintf("%x", unpack("C", $1))/eg;
      $ndata =~ s/(\w{32})/\t\t\t $1\n/g;
      if (($tmpr) = $ndata =~ /\n(\w+)$/) {
       $ndata =~ s/\n$r$/\n\t\t\t $r\n/;
      }
      $ndata =~ s/(\w{4})/$1 /g;
      print $ndata;
     }
    }
   }
   else {
    $hr = strftime "%H", localtime;
    $min = strftime "%M", localtime;
    $sec = strftime "%S", localtime;
    print "\r";
    print colored($hr, $hour);
    print colored(":", $semicolon1);
    print colored($min, $minute);
    print colored(":", $semicolon2);
    print colored($sec, $second);
    print colored(".", $dot1);
    print colored($time, $millisecond);
    print " ";
    print colored($sname, $source_ip);
    print " ";
    print colored(">", $to);
    print " ";
    print colored($dname, $destination_ip);
    print colored(":", $semicolon3);
    print " ";
    print colored("icmp", $icmp);
    print colored(":", $semicolon4);
    print " ";
    print colored("type", $type2);
    print " ";
    print colored($type, $type3);
    print " ";
    print colored("code", $code2);
    print " ";
    print colored($code, $code3);
    print " ";
    print colored("check", $check3);
    print " ";
    print colored($chk, $check4);
    print " ";
    print colored("gateway", $gateway1);
    print " ";
    print colored($gateway, $gateway2);
    print " ";
    print colored("id", $id1);
    print " ";
    print colored($id, $id2);
    print " ";
    print colored("mtu", $mtu1);
    print " ";
    print colored($mtu, $mtu2);
    if ($verb) {
     print " ";
     print colored("(", $paren3);
     print colored("ttl", $tmtl);
     print " ";
     print colored($ttl, $tttl);
     print colored(",", $comma);
     print " ";
     print colored("id", $idc);
     print " ";
     print colored($iid, $tidc);
     print colored(")", $paren4);
    }
    if ($hex and !$hexa) {
     print "\n";
     ($ndata = $data) =~ s/(.{1})/sprintf("%x", unpack("C", $1))/eg;
     $ndata =~ s/(\w{32})/\t\t\t $1\n/g;
     if (($tmpr) = $ndata =~ /\n(\w+)$/) {
      $ndata =~ s/\n$r$/\n\t\t\t $r\n/;
     }
     $ndata =~ s/(\w{4})/$1 /g;
     print $ndata;
    }
   }
   print "\n";
  }
  if ($amt and $top == $amt) {
   die "\r$amt packets recieved by filter\n";
  }
 }
 }
}

1;
